'   RECEDIT.BAS
'   Source code module for RecEdit, Version 1.0
'   Copyright  1995 Ziff-Davis Publishing Company.
'   All rights reserved.
'   First appeared in PC Magazine, US Edition, October 24, 1995.
Option Explicit
DefInt A-Z
' RECEDIT.BI contains:
'   Definitions for user-defined types
'   Global Constants
'   API function declarations
' $INCLUDE: 'RECEDIT.BI'

'Naming conventions:
'Global Subs, Functions, and variables are named using Mixed_Case_And_Underbars
'Windows API function calls begin with the prefix "API_"
'Global constants and user-defined type names are in ALL_CAPS
'Form-level Subs and Functions are in MixedCaseWithNoUnderbars
'Procedure-level variables are in lowercase

' Global variables
' Macro headers
Global M_List() As MACRO_ARRAY_RECORD, MacroCount As Integer
' Event records
Global E_List() As EVENT_ARRAY_RECORD, MaxEventCount As Integer
' Window ID information
Global wID_Ptr() As WINDOW_ID_DATA
Global Macro_Description$(), Window_ID$(), Max_wID As Integer
' Event data clipboard
Global E_Clip() As EVENT_RECORD, Clip_wID$(), Max_Clip_ID As Integer
Global Clip_Rec_Count As Integer, Clip_Has_Mouse As Integer, Clip_Data_Size As Long
' Global vars for tracking instances of the Event List
Global EL_Forms() As Form, EL_Data() As EVENT_LIST_STATUS, Num_Lists As Integer, Cur_List As Integer
' Form variables for non-MDI forms.
Global Child_Forms(1 To 3) As Form
Global Event_Undo_Buffer As EVENT_RECORD
' Name of current file.
Global Current_File$
Global Step_Count As Integer
Global FILE_HEADER As FILE_HEADER
Global Data_Changed As Integer, current_macro As Integer
Global Ini_File$
Global Macro_Undo_Buffer As MACRO_RECORD, Macro_Desc_Undo$
Global Favorite_File$(1 To 4)
'Miscellaneous string constants
Global LF As String, QT As String, TB As String, NUL As String
Global APP_TITLE As String

Sub Add_Favorite (file_spec$)
' Adds filespec to the "Favorites" list in the File Menu
Dim i, j
    'Is filespec alreay in the menu?
    For i = 1 To 4
	'If so,
	If Favorite_File$(i) = file_spec$ Then
	    ' is it at the top of the list?
	    If i > 1 Then
		'If not, move it to the top
		For j = i - 1 To 1 Step -1
		    Favorite_File$(j + 1) = Favorite_File$(j)
		Next j
		Favorite_File$(1) = file_spec$
	    Else
		'Otherwise, no need to change the menu.
		Exit Sub
	    End If
	    'Rebuild the menu
	    Build_Favorite
	    Exit Sub
	End If
    Next i
    ' File was not already in the list, so move existing entries down one notch.
    For i = 3 To 1 Step -1
	Favorite_File$(i + 1) = Favorite_File$(i)
    Next i
    ' Install the new file at the top.
    Favorite_File$(1) = file_spec$
    ' Reset the menu
    Build_Favorite
End Sub

Function Add_WindowID (ER As EVENT_RECORD, target_macro As Integer) As Integer
'Scans the Window ID string array to see if the ID string
'referenced by the current macro event is already present.
'If so, returns the index into the array where the string
'is stored. If not, it reads the string from the .REC file
'and adds it to the array, returning the new array index.
Dim filepos As Long
Dim i, j, k
Dim a$, w$
'Save file position.
    filepos = Loc(1) + 1
'Any strings stored yet? Scan arrays if so.
    If Max_wID > 0 Then
	For i = 1 To Max_wID
	    If wID_Ptr(i).owner = target_macro And wID_Ptr(i).Ptr = ER.wIDPtr Then
		Add_WindowID = i
		Exit Function
	    End If
	Next i
    End If
'If no strings stored or target string not found, then
'Expand the arrays
    Max_wID = Max_wID + 1
    ReDim Preserve wID_Ptr(1 To Max_wID), Window_ID$(1 To Max_wID)
'Initialize pointer fields.
    wID_Ptr(Max_wID).owner = target_macro
    wID_Ptr(Max_wID).Ptr = ER.wIDPtr
'Find the string in the file.
    Seek #1, M_List(target_macro).MR.ELPtr + I_to_L(ER.wIDPtr) + 3
'Read the ASCIIZ string from the file.
    w$ = ""
    Do
	a$ = Input$(1, 1)
	If Asc(a$) = 0 Then Exit Do
	w$ = w$ & a$
    Loop
'Place the string in the array.
    Window_ID$(Max_wID) = w$
'Restore file position.
    Seek #1, filepos
'Return new index to caller.
    Add_WindowID = Max_wID
End Function

Function Ask_Save (boxflags As Integer) As Integer
    API_Beep MB_ICONQUESTION
    Ask_Save = MsgBox("Current file has changed." & LF & "Do you wish to save it?", boxflags, APP_TITLE)
End Function

Sub Build_Event_List (target_macro)
'Subroutine fills the Event list box using the data
'for the current macro.
Dim our_list As Control
Dim i
    Cur_List = 0
    If Num_Lists Then
	'If there are any event list forms,
	For i = 1 To Num_Lists
	    'See if any of them holds the specified macro.
	    If EL_Data(i).m = target_macro Then
		'And set the global handle if so.
		Cur_List = i
		Exit For
	    End If
	Next i
    End If
    'If there is no event list form for the current macro,
    If Cur_List = 0 Then
	'Create a new one.
	Num_Lists = Num_Lists + 1
	ReDim Preserve EL_Data(1 To Num_Lists)
	ReDim Preserve EL_Forms(1 To Num_Lists)
	Cur_List = Num_Lists
	Set EL_Forms(Cur_List) = New frmEvents
	EL_Data(Cur_List).m = target_macro
	EL_Data(Cur_List).o = M_List(target_macro).ELP
    End If
    'Clear the list box
    Set our_list = EL_Forms(Cur_List).lstEvents
    our_list.Clear
    If M_List(target_macro).MR.KeyCode = NUL Then
	EL_Forms(Cur_List).Caption = Macro_Title$(M_List(target_macro).MR)
    Else
	EL_Forms(Cur_List).Caption = Macro_Key_Name$(target_macro)
    End If
    If E_List(EL_Data(Cur_List).o).ER.MouseX > 1 Then
	For i = 1 To E_List(M_List(target_macro).ELP).ER.MouseX - 1
	    our_list.AddItem Event_Line$(i)
	Next i
    End If
'Add a "dummy" record for end of file; this allows user
'to paste steps in _after_ the last step in the macro.
    our_list.AddItem "9999: ***End***"
'If the current step pointer is invalid (e.g. after an
'Edit/Cut operation), reset it to point to the last
'step in the macro.
    If EL_Data(Cur_List).s > E_List(M_List(target_macro).ELP).ER.MouseX - 1 Then
	EL_Data(Cur_List).s = E_List(M_List(target_macro).ELP).ER.MouseX - 1
    End If
'Make sure the current step is selected in the list.
    If EL_Data(Cur_List).s > 0 Then
	our_list.ListIndex = EL_Data(Cur_List).s - 1
    Else
	our_list.ListIndex = 0
    End If
    our_list.Selected(our_list.ListIndex) = True
    Set_Listbox_Pos our_list, EL_Forms(Cur_List)!pctDummy, -1
End Sub

Sub Build_Favorite ()
' Build the "favorite files" portion of the File Menu
Dim i, j, c, x
Dim a$, b$
    c = False
    'First, make sure all of the files exist
    x = 0
    For i = 1 To 4
	If Favorite_File$(i) <> "" Then
	    On Error GoTo No_File
	    a$ = Dir$(Favorite_File$(i))
	    On Error GoTo 0
	    If a$ = "" Then
		Favorite_File$(i) = ""
	    Else
		x = x + 1
	    End If
	End If
    Next i
    'If at least one entry is non-blank,
    If x < 4 Then
	'Compact the list to leave no gaps.
	i = 1
	Do
	    For j = i To 4
		If Favorite_File$(j) <> "" Then
		    Favorite_File$(i) = Favorite_File$(j)
		    If j <> i Then
			Favorite_File$(j) = ""
		    End If
		    Exit For
		End If
	    Next j
	    i = i + 1
	Loop Until i > x
    End If
    For i = 1 To 4
	'Get filespec
	a$ = Favorite_File$(i)
	'Not defined?
	If a$ = "" Then
	    'Hide menu item if so.
	    frmMain!mnuFileFav(i).Visible = False
	Else
	    'Is it too long?
	    'Default length allows for D:\DIRNAME1\DIRNAME2\FILESPEC.EXT
	    If Len(a$) > 33 Then
		'Find deepest subdir name
		c = 0
		For j = Len(a$) To 1 Step -1
		    If Mid$(a$, j, 1) = "\" Then
			c = c + 1
			If c = 2 Then
			    'Extract last subdir + filespec
			    b$ = Mid$(a$, j)
			    Exit For
			End If
		    End If
		Next j
		c = 0
		'Find first subdir name
		For j = 1 To Len(a$)
		    If Mid$(a$, j, 1) = "\" Then
			'Put ellipsis in place of intermediate dir names
			a$ = Left$(a$, j) & "..." & b$
			Exit For
		    End If
		Next j
	    End If
	    'Add filespec to menu
	    frmMain!mnuFileFav(i).Caption = "&" & i & " " & a$
	    frmMain!mnuFileFav(i).Visible = True
	    'Flag indicates at least one favorite filespec.
	    c = True
	End If
    Next i
    'Make separator visible only if there's at least one filespec.
    frmMain!mnuFileSep4.Visible = (c <> 0)
    Exit Sub

No_File:
    a$ = ""
    Resume Next
End Sub

Sub Build_Macro_List ()
Dim our_form As Form, our_list As Control
Dim i
    Set our_form = frmMacro
    Set our_list = frmMacro!lstMacros
    'Hide the list box so that adding items does not
    'cause Click events.
    our_list.Visible = False
    our_list.Clear
    'Make sure window state is Normal (not minimized or maximized)
    If our_form.WindowState <> NORMAL Then our_form.WindowState = NORMAL
    'Put the window in the top left corner of the main window.
    our_form.Top = 0
    our_form.Left = 0
    'Size the window to fill the width of the main window
    'but only 3/4 the height so icons will be visible at the bottom.
    our_form.Width = frmMain.ScaleWidth
    our_form.Height = frmMain.ScaleHeight * .75
    For i = 1 To MacroCount
	our_list.AddItem Macro_List_Line(M_List(i).MR)
    Next i
    our_list.Visible = True
    our_list.ListIndex = 0
    our_form.Show
End Sub

Sub Clean_Window_IDs ()
'Removes unreferenced Window ID strings before saving the
'current file.
Dim our_combo As Control
Dim i, j, k, strings_deleted
Dim x$
ReDim used(1 To Max_wID)
    'First, flag all the strings that are referenced.
    For i = 1 To MacroCount
	'For each macro that has at least one step,
	If E_List(M_List(i).ELP).ER.MouseX > 1 Then
	    'Scan the events and flag the string pointers they are using.
	    For j = M_List(i).ELP + 1 To M_List(i).ELP + E_List(M_List(i).ELP).ER.MouseX - 1
		used(E_List(j).ER.wIDPtr) = True
	    Next j
	End If
    Next i
    i = 1
    'Next, delete all the strings that _aren't_ referenced.
    Do
	If Not used(i) Then
	    'If a string was not referenced, then:
	    For j = wID_Ptr(i).owner To MacroCount
		'If the macro is not empty,
		If E_List(M_List(j).ELP).ER.MouseX > 1 Then
		    'Adjust string pointers to allow for the deletion.
		    For k = M_List(j).ELP + 1 To M_List(j).ELP + E_List(M_List(j).ELP).ER.MouseX - 1
			If E_List(k).ER.wIDPtr >= i Then E_List(k).ER.wIDPtr = E_List(k).ER.wIDPtr - 1
		    Next k
		End If
	    Next j
	    If i < Max_wID Then
		'Delete the string and pointer data from the arrays.
		For j = i To Max_wID - 1
		    Window_ID$(j) = Window_ID$(j + 1)
		    wID_Ptr(j) = wID_Ptr(j + 1)
		    used(j) = used(j + 1)
		Next j
	    End If
	    'Adjust the window ID count.
	    Max_wID = Max_wID - 1
	    'Flag that at least one string was deleted
	    strings_deleted = True
	Else
	    'Otherwise, move on to the next string.
	    i = i + 1
	End If
    Loop Until i > Max_wID
    'If no strings were deleted, we're done.
    Erase used
    If Not strings_deleted Then Exit Sub
    'Otherwise, resize the window ID arrays,
    ReDim Preserve Window_ID$(1 To Max_wID), wID_Ptr(1 To Max_wID)
    'and set each macro's event data size word.
    For i = 1 To MacroCount
	Set_Data_Size i
	'While we're at it, adjust the Event Editor's Window ID box.
	If EL_Data(Cur_List).m = i Then
	    Set our_combo = frmEdit!cmbWindowID
	    'If there's at least one Window ID in the list,
	    If our_combo.ListCount > 1 Then
		'Make sure there's a matching entry in the Window_ID$() array
		Do
		    strings_deleted = False
		    'Loop through the list box.
		    For j = 1 To our_combo.ListCount - 1
			'Get the list item text.
			x$ = our_combo.List(j)
			'Find its array index.
			k = Find_Window_ID(x$, i)
			If k = 0 Then
			    'If it's not in the array, remove the item from the list.
			    our_combo.RemoveItem j
			    'Set the flag,
			    strings_deleted = True
			    'And repeat the scan.
			    Exit For
			End If
		    Next j
		Loop Until Not strings_deleted
		'Now that we've removed non-existing strings from the list,
		'make sure that their index data is correct.
		For j = 1 To our_combo.ListCount - 1
		    x$ = our_combo.List(j)
		    k = Find_Window_ID(x$, i)
		    our_combo.ItemData(j) = k
		Next j
	    End If
	    'Resync the undo buffer
	    If EL_Data(Cur_List).s > 0 Then
		Event_Undo_Buffer = E_List(Step_Index(Cur_List)).ER
		frmEdit!cmdUndo.Enabled = False
	    End If
	End If
    Next i
End Sub

Function Confirm_Del ()
    API_Beep MB_ICONEXCLAMATION
    Confirm_Del = MsgBox("This operation is not undoable." & LF & "Press {Enter} to continue or {Esc} to cancel.", MB_OKCANCEL Or MB_ICONEXCLAMATION, APP_TITLE)
End Function

Sub Copy_Events ()
'Copies events from the current Event List window
'to the clipboard.
Dim i, index_offset
Dim our_form As Form
    Set our_form = EL_Forms(Cur_List)
    'Nothing to copy if the list is empty!
    If our_form!lstEvents.ListCount < 2 Then Exit Sub
    our_form.MousePointer = 11
    'Clear the clipboard array, size, and mouse flag.
    Zap_Clipboard
    ' Transfer Window ID list from macro to clipboard
    For i = 1 To Max_wID
	If wID_Ptr(i).owner = EL_Data(Cur_List).m Then
	    Max_Clip_ID = Max_Clip_ID + 1
	    If Max_Clip_ID = 1 Then index_offset = i - 1
	    ReDim Preserve Clip_wID$(1 To Max_Clip_ID)
	    Clip_wID$(Max_Clip_ID) = Window_ID$(i)
	    Clip_Data_Size = Clip_Data_Size + Len(Clip_wID$(Max_Clip_ID)) + 1
	End If
    Next i
    'Don't include the "dummy" EOF record!
    For i = 0 To our_form!lstEvents.ListCount - 2
	'If the list item is either selected or current,
	If (our_form!lstEvents.ListIndex = i) Or our_form!lstEvents.Selected(i) Then
	    'Expand the clipboard array
	    Clip_Rec_Count = Clip_Rec_Count + 1
	    ReDim Preserve E_Clip(1 To Clip_Rec_Count)
	    'Add the event to the clipboard array
	    E_Clip(Clip_Rec_Count) = E_List(i + EL_Data(Cur_List).o + 1).ER
	    'Adjust the Window ID pointer for the clipboard's list.
	    E_Clip(Clip_Rec_Count).wIDPtr = E_Clip(Clip_Rec_Count).wIDPtr - index_offset
	    Clip_Has_Mouse = Clip_Has_Mouse Or (Asc(E_Clip(Clip_Rec_Count).EventClass) = 2)
	End If
    Next i
    Clip_Data_Size = Clip_Data_Size + (Clip_Rec_Count * 10&)
    frmMain!mnuEditPaste = (Clip_Rec_Count <> 0)
    our_form.MousePointer = 0
End Sub

Sub Delete_Events ()
'Delete the selected events from the active Event List window
Dim i, j, remove_count, last_removed, list_offset
Dim frm As Form, lst As Control
    'Set reference to the current event list form.
    Set frm = EL_Forms(Cur_List)
    'and the list box within the form
    Set lst = EL_Forms(Cur_List)!lstEvents
    frm.MousePointer = 11
    list_offset = lst.ListIndex - lst.TopIndex
    For i = lst.ListCount - 2 To 0 Step -1
	If lst.Selected(i) Then
	    remove_count = remove_count + 1
	    If i + EL_Data(Cur_List).o + 1 < MaxEventCount Then
		For j = i + EL_Data(Cur_List).o + 1 To MaxEventCount - 1
		    E_List(j) = E_List(j + 1)
		Next j
	    End If
	    MaxEventCount = MaxEventCount - 1
	    Data_Changed = True
	    ' Save the index of the item being remove_count
	    last_removed = i
	End If
    Next i
    'Done if no records were remove_count
    If remove_count = 0 Then
	frm.MousePointer = 0
	Exit Sub
    End If
    'Resize the Event Array
    ReDim Preserve E_List(0 To MaxEventCount)
    'Fix event list pointers for remaining macros.
    E_List(M_List(EL_Data(Cur_List).m).ELP).ER.MouseX = E_List(M_List(EL_Data(Cur_List).m).ELP).ER.MouseX - remove_count
    If EL_Data(Cur_List).m < MacroCount Then
	For i = EL_Data(Cur_List).m + 1 To MacroCount
	    M_List(i).ELP = M_List(i).ELP - remove_count
	Next i
    End If
    'Adjust the event data size
    Set_Data_Size EL_Data(Cur_List).m
    'Rebuild the event list
    Build_Event_List EL_Data(Cur_List).m
    'Highlight the record after the last one deleted.
    For i = 0 To lst.ListCount - 1
	lst.Selected(i) = False
    Next i
    lst.ListIndex = last_removed
    lst.Selected(last_removed) = True
    'Disable the Cut/Paste menu items if there are no events left in the macro.
    frmMain!mnuEditCut = lst.ListCount > 1
    frmMain!mnuEditCopy = lst.ListCount > 1
    'Adjust list position so selected item is visible
    Set_Listbox_Pos lst, frm!pctDummy, list_offset
    frm.MousePointer = 0
End Sub

Sub Delete_Macro (m As Integer)
'Deletes an entire macro including its event list,
'description string, and associated window ID data.
Dim i, j, k, l, cWindow, winPtrOffset, stepPtrOffset
    'If there's only one macro, it's _real_ easy:
    If MacroCount = 1 Then
	Master_Reset
	Exit Sub
    End If
    'See if there's an Event List window for the macro being deleted
    For i = 1 To Num_Lists
	If EL_Data(i).m = m Then
	    l = i
	    Exit For
	End If
    Next i
    ' If there is an Event List window for the macro
    If l Then
	' and it's not the last Event List window,
	If Num_Lists > 1 Then
	    ' remove it and adjust the window arrays.
	    Unload EL_Forms(l)
	    If l < Num_Lists Then
		For i = l To Num_Lists - 1
		    Set EL_Forms(i) = EL_Forms(i + 1)
		    EL_Data(i) = EL_Data(i + 1)
		Next i
	    End If
	    Num_Lists = Num_Lists - 1
	    ReDim Preserve EL_Forms(1 To Num_Lists), EL_Data(1 To Num_Lists)
	Else
	    'Otherwise, remove it and zap the window arrays.
	    Unload EL_Forms(1)
	    Erase EL_Forms, EL_Data
	    Num_Lists = 0
	    Cur_List = 0
	End If
    End If
    If Num_Lists > 0 Then
	For i = 1 To Num_Lists
	    If EL_Data(i).m > m Then EL_Data(i).m = EL_Data(i).m - 1
	Next i
    End If
    'If it's the last macro, the process is easy:
    If m = MacroCount Then
	'just redimension the event list
	MaxEventCount = M_List(m).ELP - 1
	ReDim Preserve E_List(0 To MaxEventCount)
	'Redimension the window ID arrays if they're not empty.
	If Max_wID > 0 Then
	    For i = 1 To Max_wID
		If wID_Ptr(i).owner = m Then
		    Max_wID = i - 1
		    ReDim Preserve wID_Ptr(1 To Max_wID)
		    ReDim Preserve Window_ID$(1 To Max_wID)
		    Exit For
		End If
	    Next i
	End If
    Else
	'Delete Window ID strings and wID_Ptr() data for target macro
	If Max_wID > 0 Then
	    cWindow = 0
	    For i = 1 To Max_wID
		If wID_Ptr(i).owner = m Then
		    cWindow = i
		    Exit For
		End If
	    Next i
	    If cWindow Then
		winPtrOffset = cWindow
		Do
		    cWindow = cWindow + 1
		    If cWindow > Max_wID Then Exit Do
		Loop Until wID_Ptr(cWindow).owner <> m
		winPtrOffset = cWindow - winPtrOffset
		If cWindow <= Max_wID Then
		    For i = cWindow To Max_wID
			Window_ID$(i - winPtrOffset) = Window_ID$(i)
			wID_Ptr(i - winPtrOffset) = wID_Ptr(i)
			wID_Ptr(i - winPtrOffset).owner = wID_Ptr(i - winPtrOffset).owner - 1
		    Next i
		End If
		Max_wID = Max_wID - winPtrOffset
		ReDim Preserve Window_ID$(1 To Max_wID)
		ReDim Preserve wID_Ptr(1 To Max_wID)
	    Else
		For i = 1 To Max_wID
		    If wID_Ptr(i).owner > m Then wID_Ptr(i).owner = wID_Ptr(i).owner - 1
		Next i
	    End If
	End If
	stepPtrOffset = E_List(M_List(m).ELP).ER.MouseX
	'Update event window ID pointers and move event
	'records down to close the gap in the event array.
	For i = M_List(m + 1).ELP To MaxEventCount
	    'Update window pointer only if this is _not_ a
	    'list header record -- the window string pointer
	    'field is not used in the event list header.
	    If Asc(E_List(i).ER.EventClass) Then
		E_List(i).ER.wIDPtr = E_List(i).ER.wIDPtr - winPtrOffset
	    End If
	    E_List(i).owner = E_List(i).owner - 1
	    E_List(i - stepPtrOffset) = E_List(i)
	Next i
	'Adjust event count and redimension the event array.
	MaxEventCount = MaxEventCount - stepPtrOffset
	ReDim Preserve E_List(0 To MaxEventCount)
	'Update event array pointers for subsequent macros,
	'and move the macro headers down to close the gap
	'in the macro header array.
	For i = m + 1 To MacroCount
	    M_List(i).ELP = M_List(i).ELP - stepPtrOffset
	    M_List(i - 1) = M_List(i)
	    Macro_Description$(i - 1) = Macro_Description$(i)
	Next i
    End If
    'Adjust the total macro count.
    MacroCount = MacroCount - 1
    'Redimension the macro header and description arrays.
    ReDim Preserve M_List(1 To MacroCount)
    ReDim Preserve Description$(1 To MacroCount)
    'Remove the deleted macro name from the list box.
    frmMacro!lstMacros.RemoveItem m - 1
    'Adjust macro number if the last macro was deleted
    If m > MacroCount Then m = MacroCount
    'Set the proper selection in the Macro List.
    frmMacro!lstMacros.ListIndex = m - 1
    'Reset the event list offsets for all event lists
    If Num_Lists = 0 Then
	Build_Event_List m
    Else
	For i = 1 To Num_Lists
	    EL_Data(i).o = M_List(EL_Data(i).m).ELP
	Next i
    End If
    If Cur_List > Num_Lists Then Cur_List = Num_Lists
    current_macro = m
    Data_Changed = True
    frmMacro.Show
End Sub

Function English_Name$ (code As Integer, flag As Integer)
'Function returns the English name of a key based on
'its virtual key code. Parameter "flag" tells whether to
'return the long (True) or short (False) version of the name.
Dim vk, e$
    ' Mask off upper byte (scan code) to get the virtual key code.
    vk = code And &HFF
    Select Case vk
	Case &H3
	    e$ = "Break"
	Case &H8
	    If flag Then
		e$ = "Backspace"
	    Else
		e$ = "Bkspc"
	    End If
	Case &H9
	    e$ = "Tab"
	Case &HC
	    e$ = "Keypad 5"
	Case &HD
	    e$ = "Enter"
	Case &H10
	    e$ = "Shift"
	Case &H11
	    e$ = "Ctrl"
	Case &H12
	    e$ = "Alt"
	Case &H13
	    e$ = "Pause"
	Case &H14
	    If flag Then
		e$ = "Caps Lock"
	    Else
		e$ = "CapsLk"
	    End If
	Case &H1B
	    e$ = "Esc"
	Case &H20
	    e$ = "Space"
	Case &H21
	    If flag Then
		e$ = "Page Up"
	    Else
		e$ = "Pg Up"
	    End If
	Case &H22
	    If flag Then
		e$ = "Page Down"
	    Else
		e$ = "Pg Dn"
	    End If
	Case &H23
	    e$ = "End"
	Case &H24
	    e$ = "Home"
	Case &H25
	    If flag Then
		e$ = "Left Arrow"
	    Else
		e$ = "Left"
	    End If
	Case &H26
	    If flag Then
		e$ = "Up Arrow"
	    Else
		e$ = "Up"
	    End If
	Case &H27
	    If flag Then
		e$ = "Right Arrow"
	    Else
		e$ = "Right"
	    End If
	Case &H28
	    If flag Then
		e$ = "Down Arrow"
	    Else
		e$ = "Down"
	    End If
	Case &H2C
	    If flag Then
		e$ = "Print Screen"
	    Else
		e$ = "PrtScr"
	    End If
	Case &H2D
	    e$ = "Insert"
	Case &H2E
	    e$ = "Delete"
	Case &H2F
	    e$ = "Help"
	Case &H30 To &H39, &H41 To &H5A
	    e$ = Chr$(vk)
	Case &H60 To &H69
	    e$ = "Keypad " & Chr$(vk - &H30)
	Case &H6A
	    e$ = "Keypad *"
	Case &H6B
	    e$ = "Keypad +"
	Case &H6D
	    e$ = "Keypad -"
	Case &H6E
	    e$ = "Keypad ."
	Case &H6F
	    e$ = "Keypad /"
	Case &H70 To &H7F
	    e$ = "F" & (vk - &H6F)
	Case &H90
	    If flag Then
		e$ = "Num Lock"
	    Else
		e$ = "NumLk"
	    End If
	Case &H91
	    If flag Then
		e$ = "Scroll Lock"
	    Else
		e$ = "ScrlLk"
	    End If
	Case &HBA
	    If flag Then
		e$ = "Semicolon ;"
	    Else
		e$ = ";"
	    End If
	Case &HBB
	    If flag Then
		e$ = "Equal ="
	    Else
		e$ = "="
	    End If
	Case &HBC
	    If flag Then
		e$ = "Comma ,"
	    Else
		e$ = ","
	    End If
	Case &HBD
	    If flag Then
		e$ = "Hyphen -"
	    Else
		e$ = "-"
	    End If
	Case &HBE
	    e$ = "Period ."
	Case &HBF
	    e$ = "/"
	Case &HC0
	    If flag Then
		e$ = "Back Quote `"
	    Else
		e$ = "`"
	    End If
	Case &HDB
	    If flag Then
		e$ = "Left Bracket ["
	    Else
		e$ = "["
	    End If
	Case &HDC
	    If flag Then
		e$ = "Backslash \"
	    Else
		e$ = "\"
	    End If
	Case &HDD
	    If flag Then
		e$ = "Right Bracket ]"
	    Else
		e$ = "]"
	    End If
	Case &HDE
	    e$ = "Quote '"
	Case Else
	    e$ = "Unknown"
    End Select
    English_Name$ = e$
End Function

Function Event_Line$ (index As Integer)
'Builds an english description of a macro event for
'display in the event list.
Dim ER As EVENT_RECORD
Dim l$
    'Start with step number as a 4-digit string.
    ER = E_List(index + EL_Data(Cur_List).o).ER
    l$ = Right("000" & index, 4) & ":"
    'Add the event type.
    l$ = l$ & Event_Name$(ER) & TB
    'If it's a mouse event,
    If Asc(ER.EventClass) = 2 Then
	'list the mouse coordinates.
	l$ = l$ & ER.MouseX & TB & ER.MouseY & TB
    Else
	'Otherwise, list the key name.
	l$ = l$ & English_Name$(ER.MouseX, False) & TB
    End If
    'Add the event delay.
    l$ = l$ & (I_to_L(ER.Delay) * 55) & TB
    'and, finally, the window ID string.
    If Window_ID$(ER.wIDPtr) = Chr$(13) Then
	l$ = l$ & "WINDOWS!Desktop"
    Else
	l$ = l$ & Window_ID$(ER.wIDPtr)
    End If
    Event_Line$ = l$
End Function

Function Event_Name$ (ER As EVENT_RECORD)
'Returns an english description of the event type
    If Asc(ER.EventClass) = 2 Then
	Select Case Asc(ER.EventType)
	    Case 0
		Event_Name$ = "Move"
	    Case 1
		Event_Name$ = "Left Down"
	    Case 2
		Event_Name$ = "Left Up"
	    Case 4
		Event_Name$ = "Right Down"
	    Case 5
		Event_Name$ = "Right Up"
	    Case 8
		Event_Name$ = "Middle Down"
	    Case 9
		Event_Name$ = "Middle Up"
	    Case Else
		Event_Name$ = "Unknown"
	End Select
    Else
	Select Case Asc(ER.EventType)
	    Case 0
		Event_Name$ = "Key Down"
	    Case 1
		Event_Name$ = "Key Up"
	    Case 4
		Event_Name$ = "SysKey Dwn"
	    Case 5
		Event_Name$ = "SysKey Up"
	    Case Else
		Event_Name$ = "Unknown"
	End Select
    End If
End Function

Function Find_Window_ID (target_string$, target_macro)
' Searches the WindowID arrays for a window ID string
' belonging to the specified target_macro.
' Returns array index if found, 0 if not.
Dim index
    index = 1
    Find_Window_ID = 0
    If Max_wID < 1 Then Exit Function
    Do
	Select Case wID_Ptr(index).owner
	    Case Is < target_macro
		index = index + 1
	    Case Is = target_macro
		If target_string$ = Window_ID$(index) Then
		    Find_Window_ID = index
		    Exit Function
		Else
		    index = index + 1
		End If
	    Case Is > target_macro
		Exit Function
	End Select
    Loop Until index > Max_wID
End Function

Function Get_File_Name (merge) As String
Dim dbox As Control
    Set dbox = frmMain!cmnFileDialog
    'Set the common dialog box
    dbox.Filename = ""
    dbox.Filter = "Recorder Files (*.rec)|*.rec|All Files (*.*)|*.*|RecEdit backups (*.rek)|*.rek"
    dbox.Flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
    dbox.DefaultExt = "rec"
    If merge Then
	dbox.DialogTitle = "RecEdit: Merge File"
    Else
	dbox.DialogTitle = "RecEdit: Open File"
    End If
    dbox.CancelError = True
    On Error GoTo FOError
    dbox.Action = DLG_FILE_OPEN
    On Error GoTo 0
    Get_File_Name = dbox.Filename
    Exit Function
FOError:
    If Err = 32755 Then
	Get_File_Name = ""
	Exit Function
    End If
    On Error GoTo 0
End Function

Function I_to_L (x As Integer) As Long
' Converts a signed integer to a positive Long Integer
' Required because BASIC does not support unsigned numeric data types.
    If x < 0 Then
	I_to_L = 65536 + x
    Else
	I_to_L = x
    End If
End Function

Function Insert_Window_ID (target_string$, target_macro)
'Inserts a new window ID string for a macro
'Returns the array index for the inserted item.
'Also updates string pointers for macro events that are affected by the insertion.
Dim i, j, k
    'Update window string counter and resize arrays.
    Max_wID = Max_wID + 1
    ReDim Preserve wID_Ptr(1 To Max_wID)
    ReDim Preserve Window_ID$(1 To Max_wID)
    If target_macro < MacroCount Then
	'If we're not adding to the last macro,
	i = 0
	' Find the insertion point.
	Do
	    i = i + 1
	Loop Until wID_Ptr(i).owner > target_macro
	' Expand the array
	For j = Max_wID To i + 1 Step -1
	    Window_ID$(j) = Window_ID$(j - 1)
	    wID_Ptr(j) = wID_Ptr(j - 1)
	Next j
	' Update string pointers in the affected macros
	For j = target_macro + 1 To MacroCount
	    If E_List(M_List(j).ELP).ER.MouseX > 1 Then
		For k = M_List(j).ELP + 1 To M_List(j).ELP + E_List(M_List(j).ELP).ER.MouseX - 1
		    If E_List(k).ER.wIDPtr >= i Then
			E_List(k).ER.wIDPtr = E_List(k).ER.wIDPtr + 1
		    End If
		Next k
	    End If
	Next j
    Else
	'Otherwise, just add the string to the end of the array, so
	'other string pointers will not be affected.
	i = Max_wID
    End If
    'Install string data, return index to caller.
    wID_Ptr(i).owner = target_macro
    wID_Ptr(i).Ptr = 0
    Window_ID$(i) = target_string$
    'Reset the affected macro's event data size word.
    Set_Data_Size target_macro
    Insert_Window_ID = i
End Function

Function L_to_I (x As Long) As Integer
'Convert a positive Long Integer to a signed Integer
'Required because BASIC does not support unsigned numeric data types.
    If x > 32767 Then
	L_to_I = x - 65536
    Else
	L_to_I = x
    End If
End Function

Sub Load_ID_Combo (combo_box As Control, default)
'Loads specified combo box with sorted list of window ID strings for the current macro
'and selects the entry (if any) matching the specified string pointer.
Dim array_index
    combo_box.Clear
    'Scan through the Window ID arrays
    array_index = 1
    Do
	'Who owns this string?
	Select Case wID_Ptr(array_index).owner
	    'Current Macro? Add to list if so.
	    Case Is = EL_Data(Cur_List).m
		'Handle special case
		If Window_ID$(array_index) = Chr$(13) Then
		    combo_box.AddItem "WINDOWS!Desktop"
		Else
		    combo_box.AddItem Window_ID$(array_index)
		End If
		'Store its array index.
		combo_box.ItemData(combo_box.NewIndex) = array_index
		'If it's the specified default, select it.
		If array_index = default Then
		    combo_box.ListIndex = combo_box.NewIndex
		End If
	    'Already past strings for the Current Macro?
	    Case Is > EL_Data(Cur_List).m
		'Stop searching if so.
		Exit Do
	End Select
	array_index = array_index + 1
    Loop Until array_index > Max_wID
    'Add the master list entry, forcing it to appear first
    combo_box.AddItem "(Master List)", 0
    combo_box.ItemData(0) = -1
    combo_box.Enabled = True
End Sub

Function Macro_Key_Name$ (m As Integer)
Dim s$
    If M_List(m).MR.KeyCode = NUL Then
	Macro_Key_Name$ = "None"
    Else
	s$ = Shift_Prefix$(M_List(m).MR.ShiftMask)
	If s$ <> "" Then s$ = s$ & " "
	Macro_Key_Name$ = s$ & English_Name$(Asc(M_List(m).MR.KeyCode), True)
    End If
End Function

Function Macro_List_Line (MR As MACRO_RECORD) As String
'Generates a formatted line for the macro list.
Dim m$
    m$ = Shift_Prefix$(MR.ShiftMask)
    If MR.KeyCode = NUL Then
	m$ = TB
    Else
	m$ = m$ & English_Name$(Asc(MR.KeyCode), True)
    End If
    m$ = m$ & Space(27 - Len(m$)) & TB & Macro_Title$(MR)
    Macro_List_Line = m$
End Function

Function Macro_Title$ (MR As MACRO_RECORD)
'Extracts the ASCIIZ title of a macro
Dim x
    x = InStr(MR.Title, NUL)
    If x > 0 And x < 41 Then
	Macro_Title$ = Left$(MR.Title, x - 1)
    Else
	Macro_Title$ = Left$(MR.Title, 39)
    End If
End Function

Sub Master_Reset ()
'Reset program to its initial state.
Dim i
    'Set menus
    frmMain.mnuFileSave = False
    frmMain.mnuFileSaveAs = False
    frmMain.mnuFileMerge = False
    frmMain.mnuWindow = False
    frmMain.mnuEditCut = False
    frmMain.mnuEditCopy = False
    frmMain.mnuEditPaste = False
    frmMain.mnuEditDelMacro = False
    frmMain.mnuEditNew = True
    'Clear data arrays and counters
    Erase M_List, E_List, Window_ID$, wID_Ptr
    MacroCount = 0
    MaxEventCount = 0
    Max_wID = 0
    'Unload all child forms.
    Unload frmProp
    Unload frmEdit
    If Num_Lists > 0 Then
	For i = 1 To Num_Lists
	    Unload EL_Forms(i)
	Next i
	Num_Lists = 0
    End If
    Unload frmMacro
    'Erase window management arrays
    Erase EL_Data, EL_Forms
    'Update status bar
    frmMain!lblFile = "Press {Ctrl-O} to open a file for editing."
    Data_Changed = False
End Sub

Sub Mem_Full_Msg ()
    API_Beep MB_ICONSTOP
    MsgBox "RecEdit has reached its storage limit." & LF & "You may not add any more events to this file.", MB_ICONSTOP, APP_TITLE
End Sub

Sub New_Macro ()
' Adds a new macro to the file.
Dim i, m, e, tc, t$, flag
    ' Make sure the new macro has a unique name.
    If MacroCount = 0 Then
	t$ = "Untitled (0)"
    Else
	Do
	    flag = False
	    t$ = "Untitled (" & Mid$(Str$(tc), 2) & ")"
	    For i = 1 To MacroCount
		If UCase$(Macro_Title$(M_List(i).MR)) = UCase(t$) Then
		    flag = True
		    Exit For
		End If
	    Next i
	    tc = tc - flag
	Loop Until Not flag
    End If
    ' Expand the macro, description, and event arrays
    MacroCount = MacroCount + 1
    MaxEventCount = MaxEventCount + 1
    m = MacroCount
    e = MaxEventCount
    ReDim Preserve M_List(1 To m), Macro_Description$(1 To m), E_List(0 To e)
    ' Install default macro and description.
    Macro_Description$(m) = ""
    M_List(m).ELP = MaxEventCount
    M_List(m).MR.KeyCode = NUL
    M_List(m).MR.ShiftMask = NUL
    M_List(m).MR.InitShift = NUL
    M_List(m).MR.EventDataSize = 10
    M_List(m).MR.ELPtr = 0
    M_List(m).MR.DescLen = 0
    M_List(m).MR.DescPtr = 0
    M_List(m).MR.DisplayX = 0
    M_List(m).MR.DisplayY = 0
    M_List(m).MR.Title = String$(41, 0)
    Mid$(M_List(m).MR.Title, 1, Len(t$)) = t$
    ' Install the Event Header record.
    E_List(e).ER.EventType = NUL
    E_List(e).ER.EventClass = NUL
    E_List(e).ER.MouseX = 1
    E_List(e).ER.MouseY = 0
    E_List(e).ER.Delay = 0
    E_List(e).ER.wIDPtr = 0
    'Rebuild the macro list.
    Build_Macro_List
    If m = 1 Then
	'If we just created the first macro in a file,
	'set the macro pointers.
	current_macro = 1
	Cur_List = 1
	Current_File$ = "UNTITLED.REC"
	frmMain!lblFile = "Editing: UNTITLED.REC"
	'Be sure to initialize the file header.
	FILE_HEADER.FileID = &H61776
	'Build an event list for the new macro.
	Build_Event_List m
	'Load the Properties and Event Editor windows.
	Load frmProp
	Set Child_Forms(2) = frmProp
	Load frmEdit
	Set Child_Forms(3) = frmEdit
	frmMain.Arrange 3
	frmMain!mnuFileSaveAs = True
	frmMain!mnuFileMerge = True
	frmMain!mnuEditDelMacro = True
	frmMain!mnuWindow = True
	Data_Changed = False
    Else
	Data_Changed = True
    End If
    'Make sure the Macro List highlights the macro we just added.
    frmMacro!lstMacros.ListIndex = frmMacro!lstMacros.ListCount - 1
    frmMacro.Show
End Sub

Function New_Shortcut$ (max)
' Function finds the next available shortcut key for a macro.
Dim i, h, s
Dim cmb As Control
    ' First, find out which hot keys are in use
    If max <> 0 Then
	'If there's at least one macro in the current file,
	Set cmb = frmProp.cmbSelectKey
	'Start with full shift mask,
	'but don't assign combinations that don't include at least {Ctrl}
	For s = 7 To 2 Step -1
	    'Clear the key code array.
	    ReDim u(0 To 255)
	    'Determine which keys are in use with the current shift mask.
	    For i = 1 To max
		If (Asc(M_List(i).MR.ShiftMask) And 7) = s Then
		    u(Asc(M_List(i).MR.KeyCode)) = True
		End If
	    Next i
	    'See if any of the non-printable keys are available.
	    For i = 1 To cmb.ListCount - 1
		If Not u(cmb.ItemData(i)) Then
		    h = cmb.ItemData(i)
		    Exit For
		End If
	    Next i
	    If h Then Exit For
	    For i = 65 To 90
		If Not u(i) Then
		    h = i
		    Exit For
		End If
	    Next i
	    If h Then Exit For
	    For i = 48 To 57
		If Not u(i) Then
		    h = i
		    Exit For
		End If
	    Next i
	    If h Then Exit For
	Next s
	If h = 0 Then
	    New_Shortcut$ = ""
	    Exit Function
	End If
    Else
	'If no macros defined, use Shift+Ctrl+Alt+F1
	h = KEY_F1
	s = 7
    End If
    New_Shortcut$ = Chr$(h) & Chr$(s)
End Function

Sub No_REK_Msg (flag As Integer)
Dim m$
    m$ = "You cannot save a file named with the" & LF
    m$ = m$ & "extensions REK, COM, EXE, or BAT." & LF
    If flag Then
	m$ = m$ & "Use " & QT & "Save As" & QT & " from the " & QT & "File" & QT
	m$ = m$ & " menu" & LF & "to select a different filename."
    Else
	m$ = m$ & "Please select a different filename."
    End If
    API_Beep MB_ICONEXCLAMATION
    MsgBox m$, MB_ICONEXCLAMATION, APP_TITLE
End Sub

Sub Open_File (startup)
' Opens a file for editing. The "startup" parameter
' is set to True if the filespec was given on
' the command line at program start.
Dim f$, i
    ' Prompt to save current file if necessary.
    If startup Then
	f$ = Current_File$
    Else
	If Current_File$ <> "" Then
	    If Data_Changed Then
		Select Case Ask_Save(MB_YESNOCANCEL Or MB_ICONEXCLAMATION)
		    Case IDYES
			Save_As
		    Case IDCANCEL
			Exit Sub
		End Select
	    End If
	End If
	' Use common dialog box to get the filename.
	f$ = Get_File_Name(False)
	' If cancelled, we're done.
	If f$ = "" Then Exit Sub
	' Set new filename.
	Current_File$ = f$
	' Clear the decks.
    End If
    Master_Reset
    ' Try to read the file.
    If Read_File(False, f$) Then
	'If successful, set status bar text.
	frmMain!lblFile = "Editing " & f$
	'Add file to the "Favorites" list
	Add_Favorite f$
	If (GetAttr(f$) And 1) <> 0 Then
	    frmMain!lblFile = frmMain!lblFile & " (Read-Only)"
	End If
	'Enable appropriate menu items.
	frmMain!mnuFileSaveAs = True
	frmMain!mnuFileSave = True
	frmMain!mnuFileMerge = True
	frmMain!mnuWindow = True
	frmMain!mnuEdit = True
	'Initialize and display the principal child windows.
	Build_Macro_List
	frmProp.Show
	Build_Event_List 1
	If EL_Forms(Cur_List)!lstEvents.ListCount > 1 Then
	    frmEdit.txtStep = 1
	Else
	    frmEdit.txtStep = 0
	End If
	frmMacro.Show
	frmMain.Arrange 0
    Else
	'Otherwise, reset the program.
	Master_Reset
    End If
    Exit Sub
End Sub

Sub Parse_Args ()
Dim c$, x
    c$ = UCase$(LTrim$(RTrim$(Command$)))
    'Any arguments present?
    If Len(c$) Then
	'If more than one argument, use only the first.
	x = InStr(c$, " ")
	If x Then
	    c$ = Left$(c$, x - 1)
	End If
	'Check for wildcards; report error if found.
	If InStr(c$, "?") > 0 Or InStr(c$, "*") > 0 Then
	    API_Beep MB_ICONEXCLAMATION
	    MsgBox "Wildcards not allowed on command line.", MB_ICONEXCLAMATION, APP_TITLE
	    Exit Sub
	End If
	'Append default extension if necessary
	x = InStr(c$, ".")
	If x = 0 Then
	    c$ = c$ & ".REC"
	End If
	'Report error if it's a .REK file.
	If InStr(c$, ".REK") > 0 Then
	    API_Beep MB_ICONEXCLAMATION
	    MsgBox "Cannot open a file with the .REK extension.", MB_ICONEXCLAMATION, APP_TITLE
	    Exit Sub
	End If
	If Dir$(c$) = "" Then
	    'Error if file doesn't exist
	    API_Beep MB_ICONEXCLAMATION
	    MsgBox "Unable to open " & c$, MB_ICONEXCLAMATION, APP_TITLE
	Else
	    'Othewise, set filename and open it.
	    Current_File$ = c$
	    Open_File True
	End If
    End If
End Sub

Sub Paste_Events ()
'Inserts events from the event clipboard into the current
'macro, beginning at the current step.
Dim i, j, k, insertpoint, insertoffset, w, m, lineoffset
    'First, check for size limits.
    m = EL_Data(Cur_List).m
    If (I_to_L(M_List(m).MR.EventDataSize) + Clip_Data_Size) > 65535 Then
	API_Beep MB_ICONSTOP
	MsgBox "There is not enough room in the macro to hold the clipboard contents.", MB_ICONSTOP, "RecEdit - Paste Error"
	Exit Sub
    End If
    If I_to_L(Clip_Rec_Count) + MaxEventCount > 32766 Then
	API_Beep MB_ICONSTOP
	MsgBox "There is not enough memory to insert the clipboard contents.", MB_ICONSTOP, APP_TITLE
	Exit Sub
    End If
    'Error if clipboard contains mouse events and screen parms are not set.
    If Clip_Has_Mouse Then
	If M_List(m).MR.DisplayX = 0 Then
	    API_Beep MB_ICONEXCLAMATION
	    MsgBox "The RecEdit clipboard contains mouse events. You must set the mouse and screen parameters in the main window before you can paste mouse events into this macro.", MB_ICONEXCLAMATION, "RecEdit - Paste Error"
	    Exit Sub
	End If
    End If
    EL_Forms(Cur_List).MousePointer = 11
    lineoffset = EL_Forms(Cur_List)!lstEvents.ListIndex - EL_Forms(Cur_List)!lstEvents.TopIndex
    EL_Data(Cur_List).o = M_List(m).ELP
    EL_Data(Cur_List).s = EL_Forms(Cur_List)!lstEvents.ListIndex + 1
    insertpoint = Step_Index(Cur_List)
    MaxEventCount = MaxEventCount + Clip_Rec_Count
    'Resize the Event array
    ReDim Preserve E_List(0 To MaxEventCount)
    'Make a hole for the new events in the E_List() array
    For i = MaxEventCount To insertpoint + Clip_Rec_Count Step -1
	E_List(i) = E_List(i - Clip_Rec_Count)
    Next i
    'Update list pointers for remaining macros, if any.
    If m < MacroCount Then
	For i = m + 1 To MacroCount
	    M_List(i).ELP = M_List(i).ELP + Clip_Rec_Count
	    'And make sure the Event List window data
	    'is in sync with the Macro data.
	    For j = 1 To Num_Lists
		If EL_Data(j).m = i Then
		    EL_Data(j).o = M_List(i).ELP
		End If
	    Next j
	Next i
    End If
'Now, begin transferring events from the clipboard to
'the event array.
    For i = 1 To Clip_Rec_Count
	'See if the current macro has a Window ID
	'string that matches the string in the clipboard.
	w = Find_Window_ID(Clip_wID$(E_Clip(i).wIDPtr), m)
	If w = 0 Then
	    'If not, insert a new window ID for the target macro (note that this
	    'automatically updates the string pointers for all events affected by
	    'the insertion.
	    w = Insert_Window_ID(Clip_wID$(E_Clip(i).wIDPtr), m)
	End If
	'Install event data from the clipboard.
	E_List(insertpoint + i - 1).ER = E_Clip(i)
	'And replace the Window ID pointer copied from the clipboard with
	'the proper pointer for the current macro.
	E_List(insertpoint + i - 1).ER.wIDPtr = w
	'Set the new record's macro number.
	E_List(insertpoint + i - 1).owner = m
    Next i
    'Update the event count and data size for the current macro.
    E_List(M_List(m).ELP).ER.MouseX = E_List(M_List(m).ELP).ER.MouseX + Clip_Rec_Count
    Set_Data_Size m
    'Rebuild the Event List list box.
    Build_Event_List m
    Set_Listbox_Pos EL_Forms(Cur_List)!lstEvents, EL_Forms(Cur_List)!pctDummy, lineoffset
    Data_Changed = True
    'Make sure the events just pasted are selected in the
    'event list box.
    For i = -1 To Clip_Rec_Count - 2
	EL_Forms(Cur_List)!lstEvents.Selected(insertpoint - EL_Data(Cur_List).o + i) = True
    Next i
    'Set the list box pointer to the beginning of the pasted section.
    EL_Forms(Cur_List)!lstEvents.ListIndex = insertpoint - EL_Data(Cur_List).o - 1
    EL_Forms(Cur_List).MousePointer = 0
    'Since we just finished pasting events into the window,
    'we know we can enable the Cut/Copy functions on the Edit menu.
    frmMain!mnuEditCut = True
    frmMain!mnuEditCopy = True
End Sub

Function Read_File (merge_flag, input_file$) As Integer
'Function reads a .REC file and builds the associated
'arrays in memory. If the "merge_flag" parameter is "True", the
'file data is appended to that already in memory.
Dim MR As MACRO_RECORD, ER As EVENT_RECORD
Dim file_pointer As Long, event_count As Long
Dim i, j, m$
Dim block_ID_word, old_macro_count, old_event_count
Dim oldmaxwinID, current_macro, current_event
Dim new_title_index, no_keys_avail
Dim events_skipped, data_merged
Dim old_key_name$, new_key_name$
Dim new_shortcut_key$, old_title$, new_title$
    If merge_flag Then
	'If merging, preserve current status.
	oldmaxwinID = Max_wID
	old_event_count = MaxEventCount
	current_event = MaxEventCount + 1
	current_macro = MacroCount
	old_macro_count = MacroCount
    Else
	current_macro = 0
	current_event = 0
    End If
    'Update status bar
    frmMain!lblFile = "Reading " & input_file$
    frmMain!lblFile.Refresh
    'Open the file.
    On Error GoTo FileOpenError
    Open input_file$ For Binary Access Read Lock Write As #1
    On Error GoTo 0
    'Read the file header
    Get #1, , FILE_HEADER
    If FILE_HEADER.FileID <> &H61776 Then
	API_Beep MB_ICONSTOP
	MsgBox "Invalid file header", MB_ICONSTOP, APP_TITLE
	Close
	Read_File = False
	Exit Function
    End If
    MacroCount = FILE_HEADER.MacroCount + current_macro
    'Point to start of macro header data in file, and
    'make sure the word at that position is a macro block ID.
    Seek #1, FILE_HEADER.MacroInfoPtr + 1
    Get #1, , block_ID_word
    If block_ID_word <> MACRO_ID_WORD Then GoTo FileFormatError
    'Resize the macro header and description arrays.
    ReDim Preserve M_List(1 To MacroCount)
    ReDim Preserve Macro_Description$(1 To MacroCount)
    'Set general purpose error trap.
    On Error GoTo FileOtherError
    'Set hourglass cursor and get to work.
    frmMain.MousePointer = 11
    Do
	'Next macro number
	current_macro = current_macro + 1
NextRecord:
	'Read the current macro header
	Get #1, , MR
	'Clean excess garbage out of the macro title.
	new_title$ = Macro_Title$(MR)
	MR.Title = String$(41, NUL)
	If new_title$ <> "" Then Mid$(MR.Title, 1, Len(new_title$)) = new_title$
ScanRetry:
	If merge_flag Then
	    'Shortcut key assigned?
	    If MR.KeyCode = NUL Then
		'If not, check for a duplicate name.
		'Get original name
		old_title$ = Macro_Title$(MR)
		'No need to look if this is the first macro.
		If current_macro > 1 Then
		    'Scan through existing macro headers
		    For i = 1 To current_macro - 1
			'No shortcut key?
			If M_List(i).MR.KeyCode = NUL Then
			    'Same name as macro we're loading?
			    If UCase$(Macro_Title$(M_List(i).MR)) = UCase$(old_title$) Then
				Do
				    'Build a new title by prepending an index expression.
				    new_title_index = new_title_index + 1
				    new_title$ = Left$("(" & new_title_index & ") " & old_title$, 39)
				    'Make sure the new title is unique
				    For j = 1 To current_macro - 1
					If UCase$(Macro_Title$(M_List(j).MR)) = UCase$(new_title$) Then
					    'If it isn't, try the next index.
					    j = 0
					    Exit For
					End If
				    Next j
				'Continue scanning until we have a unique name
				Loop Until j <> 0
				'Install the new name and continue
				MR.ShiftMask = Chr$(Asc(MR.ShiftMask) And &HF8)
				MR.Title = String$(41, 0)
				Mid$(MR.Title, 1, Len(new_title$)) = new_title$
				MsgBox "Renaming macro from" & LF & old_title$ & LF & "to" & LF & new_title$, MB_ICONINFORMATION, "Recedit - Merge"
				Exit For
			    End If
			End If
		    Next i
		End If
	    Else
		'No need to look if this is the first macro
		If current_macro > 1 Then
		    'Scan through existing macros unless we know we've run out
		    If Not no_keys_avail Then
			For i = 1 To current_macro - 1
			    'Same base key?
			    If MR.KeyCode = M_List(i).MR.KeyCode Then
				'Same shift mask?
				If (Asc(MR.ShiftMask) And 7) = (Asc(M_List(i).MR.ShiftMask) And 7) Then
				    'Premature exit from For loop indicates duplicate found.
				    Exit For
				End If
			    End If
			Next i
		    End If
		    If (i < current_macro) Or no_keys_avail Then
			'If hot key _is_ in use, try to find an available key.
			If Not no_keys_avail Then
			    old_key_name$ = Shift_Prefix$(MR.ShiftMask) + English_Name$(Asc(MR.KeyCode), True)
			    new_shortcut_key$ = New_Shortcut$(current_macro - 1)
			Else
			    new_shortcut_key$ = ""
			End If
			If new_shortcut_key$ = "" Then
			    'If there are none, display message and continue with next macro in the file
			    If Not no_keys_avail Then
				API_Beep MB_ICONINFORMATION
				MsgBox "All shortcut keys are in use. " & LF & "Remaining macros will be merged with no shortcut assigned.", MB_ICONINFORMATION, "RecEdit - Merge"
			    End If
			    MacroCount = MacroCount - 1
			    ReDim Preserve M_List(1 To MacroCount)
			    ReDim Preserve Macro_Description$(1 To MacroCount)
			    If MacroCount >= current_macro Then
				MR.KeyCode = NUL
				If Macro_Title$(MR) = "" Then
				    MR.Title = String$(40, 0)
				    Mid$(MR.Title, 1, 12) = "(0) Untitled"
				End If
				no_keys_avail = True
				GoTo ScanRetry
			    Else
				Exit Do
			    End If
			Else
			    'Otherwise, reassign the new key and present an appropriate message.
			    MR.KeyCode = Left$(new_shortcut_key$, 1)
			    MR.ShiftMask = Chr$((Asc(MR.ShiftMask) And &HF8) Or (Asc(Right$(new_shortcut_key$, 1)) And 7))
			    new_key_name$ = Shift_Prefix$(MR.ShiftMask) + English_Name$(Asc(MR.KeyCode), True)
			    API_Beep MB_ICONINFORMATION
			    MsgBox "Shortcut key " & old_key_name$ & " is already in use." & LF & "Reassigning " & new_key_name$ & " to this macro.", MB_ICONINFORMATION, "RecEdit-Merge"
			End If
		    End If
		End If
	    End If
	    data_merged = True
	End If
	'Add the macro header to the array, and
	'set its event list pointer.
	M_List(current_macro).MR = MR
	M_List(current_macro).ELP = current_event
	'Let user know what's happening
	If MR.KeyCode = NUL Then
	    new_title$ = Macro_Title$(MR)
	Else
	    new_title$ = Macro_Key_Name$(current_macro)
	End If
	frmMain!lblFile = "Loading macro " & new_title$
	frmMain!lblFile.Refresh
	'Save the current file position.
	file_pointer = Loc(1) + 1
	'Find the start of the event data for the current macro.
	Seek #1, MR.ELPtr + 1
	'Read the word at that point and make sure it's
	'an event list ID word.
	Get #1, , block_ID_word
	If block_ID_word <> EVENT_ID_WORD Then GoTo FileFormatError
	'Read the event list header.
	Get #1, , ER
	'Extract the number of events in the macro.
	event_count = ER.MouseX - 1
	'Make sure there is enough room to hold the macro
	If I_to_L(MaxEventCount) + ER.MouseX > 32766 Then
	    'If not, show message & skip it.
	    m$ = "Not enough memory to load"
	    'Build rest of error message
	    m$ = m$ & LF & "macro " & QT & new_title$ & QT & LF
	    m$ = m$ & "Continuing with next macro in file."
	    API_Beep MB_ICONEXCLAMATION
	    MsgBox m$, MB_ICONEXCLAMATION, APP_TITLE
	    'Adjust macro count
	    MacroCount = MacroCount - 1
	    'Any macros loaded at all?
	    If MacroCount > 0 Then
		'Resize arrays.
		ReDim Preserve M_List(1 To MacroCount)
		ReDim Preserve Macro_Description$(1 To MacroCount)
	    Else
		'Otherwise, close the file and bail out.
		Close
		Read_File = False
		frmMain.MousePointer = 0
		Exit Function
	    End If
	    If MacroCount < current_macro Then
		'Done if no macro headers left
		Exit Do
	    Else
		'Otherwise, point to next macro header and keep going.
		Seek #1, file_pointer
		GoTo NextRecord
	    End If
	End If
	MaxEventCount = event_count + current_event
	'Zap the window ID pointer since it's not used in the first event record.
	ER.wIDPtr = 0
	'Resize the event array.
	ReDim Preserve E_List(0 To MaxEventCount)
	'Store the event header.
	E_List(current_event).ER = ER
	E_List(current_event).owner = current_macro
	'Read and store the remaining event records.
	i = 1
	Do
	    'Read next event from the file.
	    Get #1, , ER
	    'Make sure the critical fields are valid.
	    Select Case Validate_Event_Data(ER, i, new_title$, MR)
		'No errors.
		Case 0
		    'If so, store the event and continue with the next.
		    E_List(current_event + i).ER = ER
		    E_List(current_event + i).owner = current_macro
		    'Scan Window ID arrays and insert a new record
		    'if necessary, setting the event record's ID pointer
		    'to the array index instead of the physical file offset.
		    E_List(current_event + i).ER.wIDPtr = Add_WindowID(ER, current_macro)
		    i = i + 1
		'Data bad, user said to skip the event.
		Case 1
		    'Otherwise, adjust the macro's event count
		    MaxEventCount = MaxEventCount - 1
		    event_count = event_count - 1
		    E_List(current_event).ER.MouseX = E_List(current_event).ER.MouseX - 1
		    'Resize the event data array
		    ReDim Preserve E_List(0 To MaxEventCount)
		    events_skipped = True
		'Data bad, user said to cancel the operation
		Case 2
		    If merge_flag Then GoSub MergeReset
		    GoTo FileErrResume
	    End Select
	Loop Until i > event_count
	current_event = current_event + i
	'Does current macro have a description?
	If MR.DescPtr <> 0& Then
	    'If so, next word in file should be a description ID.
	    Seek #1, MR.DescPtr + 1
	    Get #1, , block_ID_word
	    'Read and store the macro description.
	    If block_ID_word <> DESCR_ID_WORD Then GoTo FileFormatError
	    Macro_Description$(current_macro) = Input$(MR.DescLen - 1, 1)
	Else
	    Macro_Description$(current_macro) = ""
	End If
	Seek #1, file_pointer
    Loop Until current_macro = MacroCount
    'Set successful return status.
    Read_File = True
    'Set save-on-exit flag if any macros were merged or any event records were skipped.
    Data_Changed = events_skipped Or data_merged
    current_macro = 0

FileErrResume:
    frmMain.MousePointer = 0
    Close 1
    Exit Function

FileFormatError:
    API_Beep MB_ICONSTOP
    MsgBox "Invalid file format.", MB_ICONSTOP, APP_TITLE
    Read_File = False
    Close
    If merge_flag Then GoSub MergeReset
    Exit Function

FileOtherError:
    API_Beep MB_ICONSTOP
    MsgBox "Error (code" & Str$(Err) & ") reading file.", MB_ICONSTOP, APP_TITLE
    Read_File = False
    If merge_flag Then GoSub MergeReset
    Resume FileErrResume

FileOpenError:
    API_Beep MB_ICONSTOP
    MsgBox "Unable to open " & input_file$ & LF & "Permission denied.", MB_ICONSTOP, APP_TITLE
    Read_File = False
    If merge_flag Then GoSub MergeReset
    Resume FileErrResume

MergeReset:
    frmMain.MousePointer = 0
    MaxEventCount = old_event_count
    Max_wID = oldmaxwinID
    MacroCount = old_macro_count
    ReDim Preserve M_List(1 To MacroCount)
    ReDim Preserve Macro_Description$(1 To MacroCount)
    ReDim Preserve E_List(0 To MaxEventCount)
    ReDim Preserve wID_Ptr(1 To Max_wID)
    ReDim Preserve Window_ID$(1 To Max_wID)
    Return
End Function

Sub Read_INI_File ()
Dim f As Form, d$, l, i, c
    Set f = frmMain
    ' Read position & size info from .INI file.
    ' Use default settings if .INI does not yet exist.
    f.Top = API_GPPInt("Settings", "Top", 500, Ini_File$)
    f.Left = API_GPPInt("Settings", "Left", 500, Ini_File$)
    f.Width = API_GPPInt("Settings", "Width", 7000, Ini_File$)
    f.Height = API_GPPInt("Settings", "Height", 6000, Ini_File$)
    ' Adjust coordinates if window is off the screen.
    If f.Top > Screen.Height Or f.Top < 0 Then f.Top = Screen.Height / 10
    If f.Left > Screen.Width Or f.Left < 0 Then f.Left = Screen.Width / 10
    ' Adjust size if left or bottom borders are off the screen.
    If f.Top + f.Height > Screen.Height Then f.Height = Screen.Height - f.Top
    If f.Left + f.Width > Screen.Width Then f.Width = Screen.Width - f.Left
    f.WindowState = API_GPPInt("Settings", "State", NORMAL, Ini_File$)
    ' Set confirmations menu options.
    f!mnuConfirmMacro.Checked = (API_GPPInt("Confirmations", "MacroDelete", 1, Ini_File$) <> 0)
    f!mnuConfirmEvent.Checked = (API_GPPInt("Confirmations", "EventDelete", 1, Ini_File$) <> 0)
    f!mnuConfirmMult.Checked = (API_GPPInt("Confirmations", "MultChange", 1, Ini_File$) <> 0)
    ' Get "favorite" filespecs
    d$ = Space$(256)
    For i = 1 To 4
	l = API_GPPString("Settings", "Favorite" & i, "", d$, Len(d$), Ini_File$)
	If l <> 0 Then
	    c = c + 1
	    Favorite_File$(c) = Left$(d$, l)
	End If
    Next i
    Build_Favorite
End Sub

Function Remove_Empties () As Integer
' Function deletes macros which have no events.
' Returns True if all macros are empty.
Dim i, m$
    Remove_Empties = False
    i = 1
    Do
	If E_List(M_List(i).ELP).ER.MouseX = 1 Then
	    If MacroCount = 1 Then
		API_Beep MB_ICONEXCLAMATION
		MsgBox "All macros are empty, so there is" & LF & "no data to save.", MB_APPLMODAL Or MB_ICONEXCLAMATION, APP_TITLE
		Master_Reset
		Remove_Empties = True
		Exit Function
	    Else
		m$ = "Warning: deleting empty macro" & LF & QT
		If M_List(i).MR.KeyCode = NUL Then
		    m$ = m$ & Macro_Title$(M_List(i).MR)
		Else
		    m$ = m$ & Macro_Key_Name$(i)
		End If
		m$ = m$ & QT
		API_Beep MB_ICONEXCLAMATION
		MsgBox m$, MB_APPLMODAL Or MB_ICONEXCLAMATION, APP_TITLE
		Delete_Macro i
	    End If
	Else
	    i = i + 1
	End If
    Loop Until i > MacroCount
End Function

Sub Save_As ()
Dim e$, dbox As Control
    Set dbox = frmMain!cmnFileDialog
    Do
	'Set common dialog box properties.
	dbox.Filename = Current_File$
	dbox.Filter = "Recorder Files (*.rec)|*.rec|All Files (*.*)|*.*"
	dbox.FilterIndex = 1
	dbox.Flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
	dbox.DefaultExt = "rec"
	dbox.DialogTitle = "RecEdit: Save File As"
	dbox.CancelError = True
	On Error GoTo FSACancelErr
	dbox.Action = DLG_FILE_SAVE
	On Error GoTo 0
	If (dbox.Flags And OFN_EXTENSIONDIFFERENT) <> 0 Then
	    'Get file extension.
	    e$ = Right$(dbox.Filename, 4)
	    'Is it legal?
	    If InStr(".REK.COM.EXE.BAT", e$) Mod 4 = 1 Then
		'Display message and repeat dialog if not.
		No_REK_Msg False
	    Else
		Exit Do
	    End If
	Else
	    Exit Do
	End If
    Loop
    Current_File$ = dbox.Filename
    frmMain!lblFile = "Saving " & Current_File$
    frmMain!lblFile.Refresh
    'If save is succesful,
    If Write_File() Then
	'Enable Save command on the File menu
	frmMain!mnuFileSave = True
	'Add filespec to favorites list
	Add_Favorite Current_File$
    Else
	API_Beep MB_ICONEXCLAMATION
	MsgBox "File not saved.", MB_ICONEXCLAMATION, APP_TITLE
    End If
    'Update status bar
    frmMain!lblFile = "Editing " & Current_File$
    Exit Sub

FSACancelErr:
    If Err = 32755 Then Exit Sub
    On Error GoTo 0

End Sub

Sub Set_Active_Window ()
'Used when any child window is closed.
'Sets active window to the first one that's not minimized.
Dim i
    For i = 3 To 1 Step -1
	If Child_Forms(i).WindowState <> MINIMIZED Then
	    Child_Forms(i).Show
	    Exit Sub
	End If
    Next i
    For i = Num_Lists To 1 Step -1
	If EL_Forms(i).WindowState <> MINIMIZED Then
	    EL_Forms(i).Show
	    Exit Sub
	End If
    Next i
End Sub

Sub Set_Data_Size (m)
'Set the event data size word for the specified macro
    M_List(m).MR.EventDataSize = L_to_I(E_List(M_List(m).ELP).ER.MouseX * 10& + String_Data_Size&(m))
End Sub

Sub Set_Listbox_Pos (lst As Control, pct As Control, offset)
' Sets position of current item in the specified list box.
' The pct control is needed to determine the height of a line, and it should
' be a picture box set to the same font and point size as the list box.
' The offset parameter is used to determine the method used.
' If offset is < 0, then the selected item is centered in the box.
' If offset is 0 or greater, then the current selection is positioned
' (offset) lines from the top of the box. If offset would place the item
' beyond the bottom of the list, it is placed in the middle.
Dim l, h, x
    h = lst.Height / pct.TextHeight("A")
    l = h / 2
    If offset < 0 Then
	If lst.ListCount < 2 Then Exit Sub
	If h < 3 Then
	    lst.TopIndex = lst.ListIndex
	ElseIf lst.ListIndex > l Then
	    lst.TopIndex = lst.ListIndex - l + 1
	Else
	    lst.TopIndex = 0
	End If
    Else
	x = lst.ListIndex - offset
	If x < 0 Then
	    lst.TopIndex = 0
	ElseIf offset > h Then
	    If h < 3 Then
		lst.TopIndex = lst.ListIndex
	    Else
		lst.TopIndex = lst.ListIndex - l + 1
	    End If
	Else
	    lst.TopIndex = x
	End If
    End If
End Sub

Function Shift_Prefix$ (mask As String)
'Returns an english rendition of the shift key
'status for a macro hot key.
Dim bits, p$
    bits = Asc(mask) And &H7
    If bits Then
	If bits And 1 Then p$ = "Shift+"
	If bits And 2 Then p$ = p$ & "Ctrl+"
	If bits And 4 Then p$ = p$ & "Alt+"
    Else
	p$ = ""
    End If
    Shift_Prefix$ = p$
End Function

Sub Show_Help (context)
'Activates WinHelp with the specified context displayed.
    frmMain!cmnFileDialog.HelpFile = App.HelpFile
    frmMain!cmnFileDialog.HelpContext = context
    frmMain!cmnFileDialog.HelpCommand = HELP_CONTEXT
    frmMain!cmnFileDialog.Action = DLG_HELP
End Sub

Function Step_Index (l)
    Step_Index = EL_Data(l).o + EL_Data(l).s
End Function

Function String_Data_Size& (m)
' Returns the size of the window ID strings used by
' the specified macro
Dim i, s As Long
    For i = 1 To Max_wID
	If wID_Ptr(i).owner = m Then
	    s = s + Len(Window_ID$(i)) + 1
	End If
    Next i
    String_Data_Size& = s
End Function

Sub Un_Minimize (f As Form)
    If f.WindowState = MINIMIZED Then f.WindowState = NORMAL
End Sub

Function Validate_Event_Data (ER As EVENT_RECORD, s As Integer, t$, MR As MACRO_RECORD)
Dim m$, e$
    Validate_Event_Data = 0
    e$ = "Invalid "
    Select Case Asc(ER.EventClass)
	Case 1
	    Select Case Asc(ER.EventType)
		Case 0 To 1, 4 To 5
		    Exit Function
		Case Else
		    e$ = e$ & "keyboard event type"
	    End Select
	Case 2
	    Select Case Asc(ER.EventType)
		Case 0 To 2, 4 To 5
		    Exit Function
		Case Else
		    e$ = e$ & "mouse event type"
	    End Select
	Case Else
	    e$ = e$ & "event class flag"
    End Select
    GoTo ValidateShowError
ValidatePointerCheck:
    If (I_to_L(ER.wIDPtr)) > (I_to_L(MR.EventDataSize)) Then
	e$ = "Invalid window ID pointer"
    Else
	Exit Function
    End If
ValidateShowError:
    m$ = e$ & " detected in" & LF
    m$ = m$ & "step " & s & " of macro " & QT & t$ & QT & LF & LF
    m$ = m$ & "Press {Enter} to skip this event and" & LF
    m$ = m$ & "continue with the next event in the file" & LF
    m$ = m$ & "or {Esc} to cancel the current operation." & LF & LF
    m$ = m$ & "If you elect to skip the event, you should" & LF
    m$ = m$ & "save the file to a new name."
    API_Beep MB_ICONEXCLAMATION
    If MsgBox(m$, MB_ICONEXCLAMATION Or MB_OKCANCEL, APP_TITLE) = IDOK Then
	Validate_Event_Data = 1
    Else
	Validate_Event_Data = 2
    End If
End Function

Function Write_File ()
'Writes the current macro data to the specified file.
Dim ER As EVENT_RECORD, MR As MACRO_RECORD
Dim id_string_ptr As Long
Dim i, j, id_word, error_flag, backup_name$, noREK
Dim m$, s$, w$
    'Default return status is false
    Write_File = False
    'Is file extension valid?
    If (InStr(".REK.COM.EXE.BAT", Right$(Current_File$, 4))) Mod 4 = 1 Then
	'Display error message and exit if not.
	No_REK_Msg True
	Exit Function
    End If
    'Remove any empty macros. If all of them are empty,
    'there's nothing to save!
    If Remove_Empties() Then Exit Function
    'Remove any unreferenced window ID strings.
    Clean_Window_IDs
    'Backup target file if it exists
    If Dir$(Current_File$) <> "" Then
	'Is it marked "read only"?
	If (GetAttr(Current_File$) And 1) <> 0 Then
	    'Present message if so.
	    API_Beep MB_ICONQUESTION
	    If MsgBox(Current_File$ & " is marked read-only. Save it anyway?", MB_OKCANCEL Or MB_ICONQUESTION Or MB_DEFBUTTON2, APP_TITLE) = IDCANCEL Then
		Exit Function
	    End If
	End If
	i = InStr(Current_File$, ".")
	'Create backup filename.
	If i Then
	    backup_name$ = Left$(Current_File$, i) & "REK"
	Else
	    backup_name$ = Current_File$ & ".REK"
	End If
	On Error GoTo WriteOpenError
	'Does backup already exist?
	If Dir$(backup_name$) <> "" Then
	    'Is it read-only?
	    If (GetAttr(backup_name$) And 1) <> 0 Then
		API_Beep MB_ICONQUESTION
		i = MsgBox("Backup file " & backup_name$ & LF & "is marked Read-only. Replace it?", MB_YESNOCANCEL Or MB_ICONQUESTION Or MB_DEFBUTTON2, APP_TITLE)
		Select Case i
		    Case IDYES
			SetAttr backup_name$, 0
		    Case IDNO
			noREK = True
		    Case IDCANCEL
			Exit Function
		End Select
	    End If
	    'Delete backup if it exists.
	    If Not noREK Then Kill backup_name$
	    If error_flag Then
		m$ = "Unable to delete existing backup file " & backup_name$
		GoSub OpenBomb
		Exit Function
	    End If
	End If
	If noREK Then
	    SetAttr Current_File$, 0
	    Kill Current_File$
	Else
	    Name Current_File$ As backup_name$
	End If
	If error_flag Then
	    m$ = "Unable to create backup file " & backup_name$
	    GoSub OpenBomb
	    Exit Function
	End If
    End If
    On Error GoTo WriteOpenError
    Open Current_File$ For Binary Lock Read Write As #1
    On Error GoTo 0
    If error_flag Then
	m$ = "Unable to create file " & Current_File$
	GoSub OpenBomb
	If Dir$(backup_name$) <> "" Then
	    On Error GoTo WriteOpenError
	    Name backup_name$ As Current_File$
	    On Error GoTo 0
	    If error_flag Then
		m$ = "Unable to rename backup from " & backup_name$ & LF & "to " & Current_File$
	    Else
		m$ = "Original file restored from backup."
	    End If
	    GoSub OpenBomb
	End If
	Exit Function
    End If
    'Change to hourglass mouse pointer.
    frmMain.MousePointer = 11
    'Set macro count and write file header.
    FILE_HEADER.MacroCount = MacroCount
    Put #1, , FILE_HEADER
    For i = 1 To MacroCount
	'Loc(1) is now the start of the current macro's event list block, so
	'plug it into the current macro record.
	M_List(i).MR.ELPtr = Loc(1)
	'Calculate the size of the event records, which also gives us the offset
	'for the first Window ID string
	id_string_ptr = E_List(M_List(i).ELP).ER.MouseX * 10&
	'Calculate and store the file offsets of remaining WindowID strings
	For j = 1 To Max_wID
	    If wID_Ptr(j).owner = i Then
		'Save the string offset as an unsigned integer
		wID_Ptr(j).Ptr = L_to_I(id_string_ptr)
		'Add the length of the string + terminating NUL to get the
		'offset for the next string.
		id_string_ptr = id_string_ptr + Len(Window_ID$(j)) + 1
	    End If
	Next j
	'Write the Event Block ID word.
	id_word = EVENT_ID_WORD
	Put #1, , id_word
	'Loc(1) is now the offset of the start of the event block.
	'Is description blank?
	If Macro_Description$(i) = "" Then
	    'Zero approipriate fields if so,
	    M_List(i).MR.DescPtr = 0
	    M_List(i).MR.DescLen = 0
	Else
	    'otherwise calculate offset for the description ID word
	    M_List(i).MR.DescLen = Len(Macro_Description$(i)) + 1
	    M_List(i).MR.DescPtr = Loc(1) + id_string_ptr
	End If
	'Write the first event record (the "header") directly.
	Put #1, , E_List(M_List(i).ELP).ER
	'And write the rest of the event records, if any.
	If E_List(M_List(i).ELP).ER.MouseX > 2 Then
	    For j = 1 To E_List(M_List(i).ELP).ER.MouseX - 1
		'Retrieve the event data from the event array.
		ER = E_List(M_List(i).ELP + j).ER
		'Replace window ID string array index with the physical file offset.
		ER.wIDPtr = wID_Ptr(ER.wIDPtr).Ptr
		'Write event record to the file.
		Put #1, , ER
	    Next j
	End If
	'Write the WindowID strings for the current macro.
	For j = 1 To Max_wID
	    If wID_Ptr(j).owner = i Then
		'Add the terminating NULL before writing the string.
		w$ = Window_ID$(j) & NUL
		Put #1, , w$
	    End If
	Next j
	'If macro description is not blank, write it to the file.
	If Macro_Description$(i) <> "" Then
	    id_word = DESCR_ID_WORD
	    Put #1, , id_word
	    w$ = Macro_Description$(i) & NUL
	    Put #1, , w$
	End If
    Next i
    'Loc(1) is now the beginning of the macro data block,
    'so update the header in memory.
    FILE_HEADER.MacroInfoPtr = Loc(1)
    'Write ID word for macro info blocks.
    id_word = MACRO_ID_WORD
    Put #1, , id_word
    'Write each macro record to the file.
    For i = 1 To MacroCount
	'Be sure data size word is set properly,
	Set_Data_Size i
	'Then write the data.
	Put #1, , M_List(i).MR
    Next i
    'Update the file header.
    Put #1, 1, FILE_HEADER
    'Close the file, and we're done.
    Close
    'Reset the save-on-exit query flag
    Data_Changed = False
    Write_File = True
    'Restore default mouse pointer.
    frmMain.MousePointer = 0
Exit Function

WriteOpenError:
    error_flag = True
    Resume Next

OpenBomb:
    API_Beep MB_ICONSTOP
    MsgBox m$, MB_ICONSTOP, "RecEdit - Save File"
    On Error GoTo 0
    Close
    Return
End Function

Sub Zap_Clipboard ()
    Erase E_Clip, Clip_wID$
    Clip_Rec_Count = 0
    Clip_Data_Size = 0
    Max_Clip_ID = 0
    Clip_Has_Mouse = False
    frmMain!mnuEditPaste = False
End Sub

